# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Interface

from dip.builder.types import ClassName, ModuleName


class IPythonClass(Interface):
    """ The IPythonClass interface defines the API of a Python class. """

    # The name of the class.
    class_name = ClassName()

    # The name of the module to import the class from.
    module_name = ModuleName(toolTip="The module the class is imported from",
            whatsThis="This is the name of the module from which the class "
                    "is imported from.")
