# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import adapt, Adapter, DelegatedTo, observe
from dip.shell import IShellObject

from dip.builder import IDipProject


@adapt(IDipProject, to=IShellObject)
class IDipProjectIShellObjectAdapter(Adapter):
    """ The IDipProjectIShellObjectAdapter adapts a dip project to the
    IShellObject interface.
    """

    # The name of the project.
    name = DelegatedTo('adaptee.description')

    @observe('adaptee.*')
    def _on_project_changed(self):
        """ Invoked when the project changes. """

        self.dirty = True
