# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Str


class ModuleName(Str):
    """ The ModuleName class is a string for holding the name of a Python
    module.
    """

    def __init__(self, default='', **metadata):
        """ Initialise the object. """

        # Provide default meta-data.
        metadata.setdefault('validator', r'[_A-Za-z][_A-Za-z0-9\.]*')
        metadata.setdefault('toolTip', "The name of the Python module")
        metadata.setdefault('whatsThis',
                "This is the name of the Python module.")

        super(ModuleName, self).__init__(default, **metadata)
