# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.plugins import ContributionTo, Plugin


class PluginsViewerPlugin(Plugin):
    """ The PluginsViewerPlugin class is the plugin definition for the plugins
    viewer.
    """

    # The description of the plugin as it will appear to the user.
    description = "View plugins"

    # The identifier of the plugin.
    id = 'dip.developer.plugins_viewer'

    # The actions contributed by this plugin.
    actions = ContributionTo('dip.shell.actions')

    @actions.default
    def actions(self):
        """ Create the actions. """

        from dip.developer.plugins_viewer import PluginsViewer

        plugins_viewer = PluginsViewer()

        self.bind_extension_point('dip.plugins.plugins', plugins_viewer,
                'plugins')

        return [plugins_viewer]
