# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import adapt, Adapter, DelegatedTo
from dip.shell import IUnmanagedTool

from .services_viewer import ServicesViewer


@adapt(ServicesViewer, to=IUnmanagedTool)
class ServicesViewerIUnmanagedToolAdapter(Adapter):
    """ The ServicesViewerIUnmanagedToolAdapter adapts the services viewer
    widget to the :class:`~dip.shell.IUnmanagedTool` interface.
    """

    # The identifier of the tool's action.
    id = 'dip.developer.view_services'

    # The name of the tool as it appears to the user.
    name = "Services"

    # The text of the tool's action.
    text = "&Services"

    # The plugins viewer widget.
    widget = DelegatedTo('adaptee')

    # Where toplace the tool's action.
    within = 'dip.shell.collections.view'
