# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Interface


class IStoragePolicy(Interface):
    """ The IStoragePolicy interface defines the API of a storage policy.
    """

    def __call__(self, obj, storage):
        """ The policy determines if an object is allowed to be stored in a
        particular type of :term:`storage`.

        :param obj:
            is the object to be stored.
        :param storage:
            is the :class:`~dip.io.IStorageFactory` implementation for the
            storage that can store the object, but may not be allowed to.
        :return:
            ``True`` if the object is allowed to be stored.
        """
