# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.plugins import ContributionTo, Plugin


class FilesystemPlugin(Plugin):
    """ The FilesystemPlugin class is the plugin definition for the filesystem
    based storage.
    """

    # The description of the plugin as it will appear to the user.
    description = "Allows the filesystem to be used as storage"

    # The identifier of the plugin.
    id = 'dip.storage.filesystem'

    # The storage contributed by this plugin.
    storage = ContributionTo('dip.io.storage')

    @storage.default
    def storage(self):
        """ Create the storage factories. """

        from dip.io.storage.filesystem import FilesystemStorageFactory

        return [FilesystemStorageFactory()]
