# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtCore import QFileInfo

from dip.model import adapt, Adapter, DelegatedTo
from dip.shell import IDisplay

from .filesystem_storage_location import FilesystemStorageLocation


@adapt(FilesystemStorageLocation, to=IDisplay)
class FilesystemStorageLocationIDisplayAdapter(Adapter):
    """ The FilesystemStorageLocationIDisplayAdapter adapts a
    :class:`~dip.io.storage.filesystem.FilesystemStorageLocation` to the
    :class:`~dip.shell.IDisplay` interface.
    """

    # The full name.
    name = DelegatedTo('adaptee.location')

    @IDisplay.short_name.getter
    def short_name(self):
        """ The getter for the short name. """

        name = self.adaptee.location
        if name == '':
            short_name = ''
        else:
            short_name = QFileInfo(name).fileName()

        return short_name
