# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


""" The :mod:`dip.shell` module implements the infrastructure for defining and
interfacing with a :term:`shell`.
"""


from .i_display import IDisplay
from .i_shell import IShell
from .i_shell_action import IShellAction
from .i_shell_manager import IShellManager
from .i_shell_object import IShellObject
from .i_shell_object_factory import IShellObjectFactory
from .i_tool import ITool
from .i_tool_factory import IToolFactory
from .i_unmanaged_tool import IUnmanagedTool

from .model_tool_factory import ModelToolFactory

# Make sure adapters get registered.
from . import qwidget_itool_adapter
