# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QKeySequence

from .shell_action import ShellAction


class CloseAction(ShellAction):
    """ The CloseAction class is a shell action that invokes the
    :meth:`~dip.shell.IShell.perform_close` method.
    """

    # The identifier of the action.
    id = 'dip.shell.actions.close'

    # The action's text.
    text = "&Close"

    # The action's shortcut.
    shortcut = QKeySequence.Close

    # This is set if the action is visible.
    visible = False

    def perform(self, tool):
        """ Perform the action.

        :param tool:
            is the tool.
        """

        self.shell.perform_close(tool)
