# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import implements, Model
from dip.ui import IQActionAction


@implements(IQActionAction)
class WhatsThisAction(Model):
    """ The WhatsThisAction class is an action that can be contributed to the
    'dip.shell.actions' extension point to invoke "What's This?" help.
    """

    # The identifier of the action.
    id = 'dip.shell.actions.whats_this'

    @IQActionAction.action.default
    def action(self):
        """ Return the default QAction. """

        from PyQt4.QtGui import QWhatsThis

        action = QWhatsThis.createAction()
        action.setObjectName(self.id)

        return action
