# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Interface, Str


class IDisplay(Interface):
    """ The IDisplay interface defines the metadata that an object may provide
    so that it can be referred to in a GUI and be recognisable by the user.
    It's use is usually optional, i.e. an application will normally try to use
    other information if an object does not implement this interface.
    """

    # The full name of the object.  This should uniquely identify the object
    # to the user.
    name = Str()

    # The optional short name of the object.
    short_name = Str()
