# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Interface, Str


class IShellObjectFactory(Interface):
    """ The IShellObjectFactory interface defines the API for factories of
    :term:`shell objects<shell object>`.
    """

    # The name of the type of the shell object.
    name = Str()

    # The identifier of the object's native format.
    native_format = Str()

    def __call__(self, shell):
        """ Create an instance of the shell object.

        :param shell:
            is the shell.

        :return:
            the instance of the shell object which must implement
            :class:`~dip.shell.IShellObject` or be able to be adapted to it.
        """
