# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Any, Instance, Interface

from .i_tool_factory import IToolFactory


class ITool(Interface):
    """ The ITool interface defines the API of a :term:`tool` than operates on
    a :term:`shell object` and relies on a :term:`shell manager` to manage the
    lifecycle of the object.
    """

    # The factory that created the tool.
    factory = Instance(IToolFactory)

    # The :term:`shell object` that the tool is operating on.  This will be
    # able to be adapted to :class:`~dip.tools.IShellObject` (or implement that
    # interface explicitly).
    obj = Any()
