# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QWidget

from dip.model import Instance, Str
from dip.ui import IQActionAction


class IUnmanagedTool(IQActionAction):
    """ The IUnmanagedTool interface defines the API of an
    :term:`unmanaged tool`.
    """

    # The name of the tool as it appears to the user.
    name = Str()

    # The :class:`~PyQt4.QtGui.QWidget` sub-class that implements the tool.
    widget = Instance(QWidget)
