# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Instance, implements, List, Model, Str

from .i_action import IAction


@implements(IAction)
class ActionCollection(Model):
    """ The ActionCollection class represents a collection of
    :term:`actions<action>` or sub-collections.
    """

    # The members of the collection.  A string is the identifier of an action
    # and is a placeholder for it.
    members = List(Instance(IAction, str))

    # The optional text to be used in any visualisation of the collection.  A
    # collection without a title may be visualised differently to one with a
    # title.
    title = Str()
