# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QValidator


class BaseValidator(QValidator):
    """ The BaseValidator class is a base class for a
    :class:`~PyQt4.QtGui.QValidator` that supplies a reason why the input is
    invalid.  The reason is saved in the ``dip_invalid_reason`` attribute after
    :meth:`~PyQt4.QtGui.QValidator.validate` method is called.
    """

    def __init__(self, parent=None):
        """ Initialise the validator.

        :param parent:
            is the optional parent object.
        """

        super(BaseValidator, self).__init__(parent)

        self.dip_invalid_reason = ''
