# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtCore import QFile

from .base_validator import BaseValidator


class FileValidator(BaseValidator):
    """ The FileValidator class is a validator that checks that the input is
    the name of an existing file.
    """

    def validate(self, input, pos):
        """ Validate the input.

        :param input:
            is the input to validate.
        :param pos:
            is the current position within the input.
        :return:
            a 3-tuple of the state, possibly modified input and possibly
            modified position.
        """

        if input == '' or QFile(input).exists():
            state = self.Acceptable
            self.dip_invalid_reason = ''
        else:
            state = self.Intermediate
            self.dip_invalid_reason = "the name of an existing file is " \
                    "required"

        return state, pos
