# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QAction, QKeySequence

from dip.model import Instance, Str

from .i_action import IAction


class IQActionAction(IAction):
    """ The IQActionAction interface defines the API for an :term:`action` that
    is implemented as a :class:`~PyQt4.QtGui.QAction`.
    """

    # The :class:`~PyQt4.QtGui.QAction` that is the actual action.
    action = Instance(QAction)

    # The action's shortcut.
    shortcut = Instance(QKeySequence, QKeySequence.StandardKey, str)

    # The action's status tip.  The naming convention is to maintain
    # compatibility with the standard QAction property.
    statusTip = Str()

    # The action's text.
    text = Str()

    # The action's tool tip.  The naming convention is to maintain
    # compatibility with the standard QAction property.
    toolTip = Str()
