# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Instance, Interface

from .i_toolkit import IToolkit


class IView(Interface):
    """ The IView interface defines the API to be implemented (typically
    using adaptation) by a :class:`~PyQt4.QtGui.QLayout` or
    :class:`~PyQt.QtGui.QWidget` created by a :class:`~dip.ui.ViewFactory`.
    """

    # The controller.
    controller = Instance('dip.ui.IController')

    # The factory that created this view.
    factory = Instance('dip.ui.ViewFactory')

    # The toolkit that created this view.
    toolkit = Instance(IToolkit)

    def configure(self):
        """ Configure the view.  This is called when everything else has been
        set up.
        """
