# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import Instance, Model, TypeFactory

from .editor_factory import EditorFactory


class ListColumn(Model):
    """ The ListColumn class represents the meta-data of the column of a list.
    """

    # The type of the column.  It is ignored unless a list element is an
    # :class:`~dip.model.Any` value.
    column_type = Instance(TypeFactory)

    # The factory for the editor created to edit a value in the column.  It
    # will default to the editor factory provided by the toolkit for the type
    # of the value.
    editor_factory = Instance(EditorFactory)
