# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.plugins import ContributionTo, Plugin, Service
from dip.ui import IToolkit


class QtToolkitPlugin(Plugin):
    """ The QtToolkitPlugin class is the plugin definition for the default Qt
    toolkit.
    """

    # The description of the plugin as it will appear to the user.
    description = "The Qt toolkit"

    # The identifier of the plugin.
    id = 'dip.ui.qt_toolkit'

    # The i/o manager service contributed by this plugin.
    qt_toolkit = ContributionTo('dip.plugins.services')

    @qt_toolkit.default
    def qt_toolkit(self):
        """ Create the Qt toolkit. """

        from dip.ui.toolkits.qt import QtToolkit

        qt_toolkit = QtToolkit()

        return [Service(interface=IToolkit, implementation=qt_toolkit)]
