# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .composite_view_factory import CompositeViewFactory


class Splitter(CompositeViewFactory):
    """ The Splitter class arranges its contents in a splitter. """

    def create_view(self, controller, toolkit, parent):
        """ Create a splitter view.

        :param controller:
            is the controller.
        :param toolkit:
            is the :class:`~dip.ui.IToolkit` implementation used to create the
            splitter.
        :param parent:
            is the optional parent widget.
        :return:
            the :class:`~PyQt4.QtGui.QWidget` instance that is the view's
            implementation.
        """

        subviews = self.create_subviews(controller, toolkit, parent)
        view = toolkit.splitter(self, subviews)
        self.bind(view, controller, toolkit)

        return view
