# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .box_layout_factory import BoxLayoutFactory


class VBox(BoxLayoutFactory):
    """ The VBox class arranges its contents vertically. """

    def create_layout(self, items, toolkit):
        """ Create a layout for a vertical sub-view.

        :param items:
            is a sequence of :class:`~PyQt4.QtGui.QLayout`,
            :class:`~PyQt4.QtGui.QWidget` and :class:`~dip.ui.Stretch`
            instances.
        :param toolkit:
            is the :class:`~dip.ui.IToolkit` implementation used to create the
            layout.
        :return:
            the layout.
        """

        return toolkit.v_box(self, items)
