# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .single_subview_factory import SingleSubviewFactory


class WizardPage(SingleSubviewFactory):
    """ The WizardPage class implements a :class:`~PyQt4.QtGui.QWizardPage`
    based wizard page.
    """

    def create_view(self, controller, toolkit, parent):
        """ Create the view for a model.

        :param controller:
            is the controller.
        :param toolkit:
            is the :class:`~dip.ui.IToolkit` implementation used to create the
            dialog.
        :param parent:
            is the optional parent widget.
        :return:
            the :class:`~PyQt4.QtGui.QLayout` or :class:`~PyQt4.QtGui.QWidget`
            that is the root of the view's implementation.
        """

        # Create the contents.  This will be a list of one element.
        subviews = self.create_subviews(controller, toolkit, None)

        view = toolkit.wizard_page(self, subviews[0], parent)
        self.bind(view, controller, toolkit)

        return view
