from PyQt4.QtGui import QDialogButtonBox

from dip.automate import AutomationCommands

# We are automating a non-dip application so we need to be explicit about the
# toolkit.
import dip.ui.toolkits.qt


class AutomateName(AutomationCommands):
    """ This automation command will set the 'name' widget in the dialog. """

    def record(self, robot):
        robot.record('dialog.person:name', 'set', self.value)


class AutomateAge(AutomationCommands):
    """ This automation command will set the 'age' widget in the dialog. """

    def record(self, robot):
        robot.record('dialog.person:age', 'set', self.value)


class AutomateOk(AutomationCommands):
    """ This automation command will click the Ok button of the dialog. """

    def record(self, robot):
        robot.record('dialog.person', 'click', QDialogButtonBox.Ok)


# Create the command sequence.
automation_commands = (AutomateName("Bill"), AutomateAge(30), AutomateOk())
