# Copyright (c) 2010 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from dip.model import implements, Model
from dip.shell import IShellObjectFactory


@implements(IShellObjectFactory)
class PyModuleFactory(Model):
    """ The PyModuleFactory class is the factory for a :term:`shell object`
    that implements a Python module.
    """

    # The name of the type of the object.
    name = "Python module"

    # The identifier of a project's native format.
    native_format = 'dip.examples.py_module.format'

    def __call__(self, shell):
        """ Create an instance of the shell object.

        :param shell:
            is the shell.

        :return:
            the instance of the shell object.
        """

        from .py_module import PyModule

        return PyModule()
