from dip.model import Instance, Interface, List

from stock import IStockLevels

from .i_recipe import IRecipe

class IRecipeChooser(Interface):
    """ The IRecipeChooser interface defines the API of a recipe chooser. """

    # The list of available recipes.
    recipes = List(IRecipe)

    # The provider of data on stock levels of ingredients.
    stock_levels = Instance(IStockLevels)

    def choose(self):
        """ Choose a recipe. """
