from dip.plugins import ContributionTo, Plugin

class RecipesPlugin(Plugin):
    """ The RecipesPlugin class is the definition of a plugin that contributes
    a number of recipes. """

    # The identifier of the plugin.
    id = 'recipes.plugins.recipes'

    # The description of the plugin as it will appear to the user.
    description = "The recipes plugin"

    # The value of this attribute will be contributed to the extension point.
    recipes = ContributionTo('recipes.recipes')

    @recipes.default
    def recipes(self):
        """ Create the list of recipes contributed to the extension point. """

        from recipes.recipes import CheeseSandwich, FrozenPizza

        return [CheeseSandwich(), FrozenPizza()]
