from dip.model import implements, Model

from recipes import IRecipeChooser

@implements(IRecipeChooser)
class RecipeChooser(Model):
    """ The RecipeChooser class implements the IRecipeChooser interface. """

    def choose(self):
        """ Choose a recipe. """

        # This always chooses the recipe that is quickest to cook.  Note that
        # we ignore the stock levels of the ingredients - but this is only an
        # example.
        quickest = None

        for recipe in self.recipes:
            if quickest is None or quickest.cooking_time > recipe.cooking_time:
                quickest = recipe

        return quickest
