import sys

from PyQt4.QtGui import QApplication, QMainWindow

from dip.ui import Action, ActionCollection, MenuBar
from dip.ui.toolkits.qt import QtToolkit


# Every PyQt GUI application needs a QApplication.
app = QApplication(sys.argv)

# We need a toolkit to create the widgets.
toolkit = QtToolkit()

# Create the main window.
main_window = QMainWindow()

# Create the action.
exit_action = Action(text="&Exit", triggered=app.quit)

# Define the action hierarchy.
action_collection = ActionCollection(title="&File", members=[exit_action])

# Create the factory that will create instances of the action hierarchy.
menu_bar = MenuBar(action_collection)

# Create an instance of the action hierarchy using QMenuBar and QMenu.
qmenubar = menu_bar(toolkit)

# Add the menu hierarchy to the main window.
main_window.setMenuBar(qmenubar)

# Make the main window visible.
main_window.show()

# Enter the event loop.
app.exec_()
