import sys

from PyQt4.QtGui import QApplication, QHBoxLayout, QWidget

from dip.model import Int, Model, Str
from dip.ui import Form, SpinBox
from dip.ui.toolkits.qt import QtToolkit


# Define the model.
class ExampleModel(Model):

    # The name.
    name = Str(toolTip="The person's full name")
    
    # The age in years.
    age = Int(minimum=0, maximum=120)


# Every PyQt GUI application needs a QApplication.
app = QApplication(sys.argv)

# We need a toolkit to create the widgets.
toolkit = QtToolkit()

# Create the model.
model = ExampleModel()

# Define the view.
view = Form('name', SpinBox('age', suffix=" years"))

# Create two instances of the view bound to the same model.
ui_left = view(model, toolkit)
ui_right = view(model, toolkit)

# Create a regular PyQt widget showing the two views side by side.
layout = QHBoxLayout()
layout.addWidget(ui_left)
layout.addWidget(ui_right)

ui = QWidget()
ui.setLayout(layout)
ui.show()

# Enter the event loop.
app.exec_()

# Show the value of the model.
print("Name:", model.name)
print("Age:", model.age)
